
freq = 1000;%*2^(1-6);
tau = logspace(ceil(log10(1/freq)+1),floor(log10(size(inertial_data2,2)/freq/4)),(floor(log10(size(inertial_data2,2)/freq/4))-ceil(log10(1/freq)))*10);

astd = allan_variance(bsxfun(@times,repmat([scale_acc scale_acc scale_acc scale_gyro scale_gyro scale_gyro]',nr_imus,1),double(inertial_data2)),freq,tau);
astdm = allan_variance(repmat([scale_acc*eye(3) zeros(3);zeros(3) scale_gyro*eye(3)]/nr_imus,1,nr_imus)*double(inertial_data2),freq,tau);

figure(10), clf, set(gca,'XScale','log','YScale','log'), axis([tau(1) tau(end) 10^-1 10^2]), set(gca,'ColorOrder',[0 0 1;0 1 0;1 0 0]), grid on, hold on
title('Accelerometer -- Allan variance'); xlabel('Cluster time [s]'); ylabel('Allan standard deviation [m/s/h]')
loglog(tau,astd(logical(repmat([1 1 1 0 0 0]',nr_imus,1)),:)*3600);
loglog(tau,astdm(1:3,:)*3600,'LineWidth',2);

figure(11), clf, set(gca,'XScale','log','YScale','log'), axis([tau(1) tau(end) 10^0 10^3]), set(gca,'ColorOrder',[0 0 1;0 1 0;1 0 0]), grid on, hold on
title('Gyroscope -- Allan variance'); xlabel('Cluster time [s]'); ylabel('Allan standard deviation [/h]')
loglog(tau,astd(logical(repmat([0 0 0 1 1 1]',nr_imus,1)),:)*3600);
loglog(tau,astdm(4:6,:)*3600,'LineWidth',2);

% Vikta med covariansen
astdw = zeros(6,numel(tau));
for i=1:6
    select = zeros(6,1);    select(i)=1;
    f_x = double(inertial_data2(logical(repmat(select,nr_imus,1)),:));
    tmp = inv(cov(f_x'));
    wf_x = sum(tmp)/sum(sum(tmp));
    f_mean = wf_x*f_x;
    astdw(i,:) = allan_variance(f_mean,freq,tau);
end
figure(10)
loglog(tau,astdw(1:3,:)*scale_acc*3600,':','LineWidth',2);
figure(11)
loglog(tau,astdw(4:6,:)*scale_gyro*3600,':','LineWidth',2);

% astdw = zeros(3,numel(tau));
% for i=1:3
%     select = zeros(6,1);    select(i+3)=1;
%     f_x = double(inertial_data2(logical(repmat(select,nr_imus,1)),:));
%     tmp = inv(cov(f_x'));
%     wf_x = sum(tmp)/sum(sum(tmp));
%     f_mean = wf_x*f_x;
%     astdw(i,:) = allan_variance(f_mean*scale_gyro,freq,tau);
% end
% loglog(tau,astdw*3600,':','LineWidth',2);

% select_f = logical(repmat([1 1 1 0 0 0]',nr_imus,1));
% select_g = logical(repmat([0 0 0 1 1 1]',nr_imus,1));
% select_x = logical(repmat([1 0 0]',nr_imus,1));
% select_y = logical(repmat([0 1 0]',nr_imus,1));
% select_z = logical(repmat([0 0 1]',nr_imus,1));
% f_data = double(inertial_data2(select_f,:));
% g_data = double(inertial_data2(select_g,:));
% f_mean = [mean(f_data(select_x,:),1); mean(f_data(select_y,:),1); mean(f_data(select_z,:),1)];
% g_mean = [mean(g_data(select_x,:),1); mean(g_data(select_y,:),1); mean(g_data(select_z,:),1)];
% astdf = allan_variance(f_data*scale_acc,freq,tau);
% astdg = allan_variance(g_data*scale_gyro,freq,tau);
% % Vikta med variansen av diffen
% figure(10)
% wx=1./(astdf(select_x,1).^2);
% wx= wx/sum(wx);
% wy=1./(astdf(select_y,1).^2);
% wy= wy/sum(wy);
% wz=1./(astdf(select_z,1).^2);
% wz= wz/sum(wz);
% f_mean = [wx'*f_data(select_x,:); wy'*f_data(select_y,:); wz'*f_data(select_z,:)];
% astdwmf = allan_variance(f_mean*scale_acc,freq,tau);
% loglog(tau,astdwmf(1,:)*3600,'k--','LineWidth',2);
% loglog(tau,astdwmf(2,:)*3600,'k--','LineWidth',2);
% loglog(tau,astdwmf(3,:)*3600,'k--','LineWidth',2);
% 
% figure(11)
% wx=1./(astdg(select_x,1).^2);
% wx= wx/sum(wx);
% wy=1./(astdg(select_y,1).^2);
% wy= wy/sum(wy);
% wz=1./(astdg(select_z,1).^2);
% wz= wz/sum(wz);
% g_mean = [wx'*g_data(select_x,:); wy'*g_data(select_y,:); wz'*g_data(select_z,:)];
% astdwmg = allan_variance(g_mean*scale_gyro,freq,tau);
% loglog(tau,astdwmg(1,:)*3600,'k--','LineWidth',2);
% loglog(tau,astdwmg(2,:)*3600,'k--','LineWidth',2);
% loglog(tau,astdwmg(3,:)*3600,'k--','LineWidth',2);
