function [sigma,err]=allan_variance(data,fs,tau)

 
% Length of data vector
[D,N]=size(data);

M=length(tau);

% Data window lengths 
W=floor(fs*tau);

sigma=zeros(D,M);
err=zeros(D,M);

 
for m=1:M
    
    Omega=zeros(D,floor(N/W(m)));
    
    for k=1:size(Omega,2)
       Omega(:,k)=mean(data(:,W(m)*(k-1)+1:W(m)*k),2);    
    end
    sigma(:,m)=sqrt(0.5*mean((diff(Omega,1,2)).^2,2));
    
    err(m)=1/sqrt(2*(N/W(m)-1));
    
end 
end
