
function W = covariance_weighting(inertial_data,C,nr_imus)

% Split data
tmp = logical(repmat([1 1 1 0 0 0]',nr_imus,1));
f_data = double(inertial_data(tmp,:));
tmp = logical(repmat([0 0 0 1 1 1]',nr_imus,1));
g_data = double(inertial_data(tmp,:));

% Transform data
tmp = reshape([C(:,1:3) zeros(nr_imus,3*nr_imus)]',3*nr_imus,nr_imus+1)';
tmp = tmp(1:end-1,:);
f_x = tmp*f_data;
tmp = reshape([C(:,4:6) zeros(nr_imus,3*nr_imus)]',3*nr_imus,nr_imus+1)';
tmp = tmp(1:end-1,:);
f_y = tmp*f_data;
tmp = reshape([C(:,7:9) zeros(nr_imus,3*nr_imus)]',3*nr_imus,nr_imus+1)';
tmp = tmp(1:end-1,:);
f_z = tmp*f_data;

tmp = reshape([C(:,10:12) zeros(nr_imus,3*nr_imus)]',3*nr_imus,nr_imus+1)';
tmp = tmp(1:end-1,:);
g_x = tmp*g_data;
tmp = reshape([C(:,13:15) zeros(nr_imus,3*nr_imus)]',3*nr_imus,nr_imus+1)';
tmp = tmp(1:end-1,:);
g_y = tmp*g_data;
tmp = reshape([C(:,16:18) zeros(nr_imus,3*nr_imus)]',3*nr_imus,nr_imus+1)';
tmp = tmp(1:end-1,:);
g_z = tmp*g_data;

% Calculate weighting
tmp = inv(cov(f_x'));
wf_x = ones(1,nr_imus)*tmp/sum(sum(tmp));
tmp = inv(cov(f_y'));
wf_y = ones(1,nr_imus)*tmp/sum(sum(tmp));
tmp = inv(cov(f_z'));
wf_z = ones(1,nr_imus)*tmp/sum(sum(tmp));

tmp = inv(cov(g_x'));
wg_x = ones(1,nr_imus)*tmp/sum(sum(tmp));
tmp = inv(cov(g_y'));
wg_y = ones(1,nr_imus)*tmp/sum(sum(tmp));
tmp = inv(cov(g_z'));
wg_z = ones(1,nr_imus)*tmp/sum(sum(tmp));

W = nr_imus*[wf_x' wf_x' wf_x' wf_y' wf_y' wf_y' wf_z' wf_z' wf_z' wg_x' wg_x' wg_x' wg_y' wg_y' wg_y' wg_z' wg_z' wg_z'];
if nr_imus~=32
    W = [W; zeros(32-nr_imus,18)];
end

figure(1), clf, hold on
plot(f_x','b');
plot(f_y','g');
plot(f_z','r');

figure(2), clf, hold on
plot(f_data')

end